/* -------------------------------------------------------------------	*/
/* Copyright (C) 2000 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.6								*/
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include <setup.h>

preface(fp) FILE *fp;
{
int pagewidth=BOXSIZE*(PAGEWIDTH/BOXSIZE);

fprintf(fp,"%%!\n%%%%BoundingBox: -20 -20 510 750\n\n");
fprintf(fp,"/dot\n{ newpath\n%5.2f 0 360 arc\nfill\n}  def\n\n",DOTSIZE);
fprintf(fp,"/delta %d def\n/offset delta %d div def\n/ticksize %d def\n",
	BOXSIZE,OFFSET,TICKSIZE);
fprintf(fp,"/pagewidth 22 delta mul def\n/pageheight %d def\n\n",
	 PAGEHEIGHT);
fprintf(fp,"/htick\n{\n-.5 ticksize mul 0 rmoveto\nticksize     0 rlineto\n");
fprintf(fp,"stroke\n} def\n\n");
fprintf(fp,"/vtick\n{\n  0 -.5 ticksize mul rmoveto\n  0 ticksize rlineto\n");
fprintf(fp,"stroke\n} def\n\n");
fprintf(fp,"/Times-Roman findfont offset 4 mul scalefont setfont\n");
fprintf(fp,"/write\n{\ndup stringwidth pop 2 div neg\n");
fprintf(fp,"offset 2 div neg rmoveto\nshow } def\n");
}


newpage(fp,s_lo,st_lo,name) FILE *fp; int s_lo,st_lo; char *name;
{
int s;

fprintf(fp,"\n%5.2f setlinewidth\n\n",LINEWIDTH);
fprintf(fp,"\ndelta delta translate\n\n");
for (s=0; s*BOXSIZE < PAGEHEIGHT ; s++)
{ if (!(3&(s+s_lo))) 
    { fprintf(fp,".6 setgray\n");
      fprintf(fp,
      "0 %d delta mul moveto\npagewidth %d delta mul lineto stroke\n",
       s,s);
    }
}
fprintf(fp,"0 setgray\n");
fprintf(fp,"\n");
if (s_lo == 0)
  fprintf(fp,"delta delta pagewidth \n{0 moveto\nvtick\n} for\n\n");
fprintf(fp,"delta delta pageheight \n{0 exch moveto\nhtick\n} for\n\n");
fprintf(fp,"delta delta pageheight \n{pagewidth exch moveto\nhtick\n} for\n\n");
/*  fprintf(fp,"delta delta translate\n\n"); */
fprintf(fp,"delta 3 mul delta 26 mul moveto\n");
fprintf(fp,"(%s from s,n=%d,%d)\n",name,s_lo,st_lo);
fprintf(fp,"write\n\n");

}

endpage(fp) FILE *fp;
{
fprintf(fp,"\nshowpage\n");
}


makedot(fp,s,n,posn) FILE *fp; int s,n,posn;
{
if (posn == 0)
  fprintf(fp,"\ndelta %d mul delta %d mul dot\n",n,s);
else if (posn & 1)
{ fprintf(fp,"\ndelta %d mul offset %d mul sub ",n,(1+posn)>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul add dot\n",s,(1+posn)>>1);
}
else 
{ fprintf(fp,"\ndelta %d mul offset %d mul add ",n,posn>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul sub dot\n",s,posn>>1);
}
}


cnnct(fp,s1,n1,posn1,s2,n2,posn2,type) FILE *fp;
					 int s1,n1,posn1,s2,n2,posn2,type;
{
if (type == 0) return(0);
if (posn1 == 0)
  fprintf(fp,"\ndelta %d mul delta %d mul moveto\n",n1,s1);
else if (posn1 & 1)
{ fprintf(fp,"\ndelta %d mul offset %d mul sub ",n1,(1+posn1)>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul add moveto\n",s1,(1+posn1)>>1);
}
else 
{ fprintf(fp,"\ndelta %d mul offset %d mul add ",n1,posn1>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul sub moveto\n",s1,posn1>>1);
}

if (posn2 == 0)
  fprintf(fp,"\ndelta %d mul delta %d mul lineto \n",n2,s2);
else if (posn2 & 1)
{ fprintf(fp,"\ndelta %d mul offset %d mul sub ",n2,(1+posn2)>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul add lineto \n",s2,(1+posn2)>>1);
}
else 
{ fprintf(fp,"\ndelta %d mul offset %d mul add ",n2,posn2>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul sub lineto \n",s2,posn2>>1);
}
switch (type)
{ case 1: fprintf(fp," [] 0 setdash stroke\n");
          break;
  case 2: fprintf(fp,"[delta 20 div ] 0 setdash stroke \n");
	  break;
  case 3: fprintf(fp,"[delta 10 div] 0 setdash  stroke \n");
	  break;
  case 4: fprintf(fp,"[delta 5 div delta 10 div] 0 setdash stroke \n");
  default: break;
}

}


writename(fp,s,n,posn,name) FILE *fp; int s,n,posn; char *name;
{
if (posn == 0)
  fprintf(fp,"\ndelta %d mul delta %d mul moveto\n",n,s);
else if (posn & 1)
{ fprintf(fp,"\ndelta %d mul offset %d mul sub ",n,(1+posn)>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul add moveto\n",s,(1+posn)>>1);
}
else 
{ fprintf(fp,"\ndelta %d mul offset %d mul add ",n,posn>>1);
  fprintf(fp,"\ndelta %d mul offset %d mul sub moveto\n",s,posn>>1);
}
fprintf(fp," (%s) write\n",name);
}
